local frame = CreateFrame("FRAME")
frame:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("PLAYER_LEVEL_UP")
frame:RegisterEvent("QUEST_LOG_UPDATE")

local quiet = false

local function eventHandler(self, event, ...)
  if event == "PLAYER_LEVEL_UP" then
    quiet = false
  else
    local totalXP = 0
    local temp = GetQuestLogSelection()

    for i = 1, select(1, GetNumQuestLogEntries()) do
      local isHeader = select(5, GetQuestLogTitle(i))
      local questIsCompleted = true
      
      if not isHeader then      
        for j = 1, GetNumQuestLeaderBoards() do
          if select(3, GetQuestLogLeaderBoard(j)) ~= 1 then
            questIsCompleted = false
          end
        end
        
        if questIsCompleted then
          SelectQuestLogEntry(i)
          totalXP = totalXP + GetQuestLogRewardXP()
        end
      end
    end

    if (UnitXPMax("player") - UnitXP("player")) - totalXP <= 0 and quiet == false then
      print("Turning in your completed quests will give you enough XP to level up!")
      quiet = true
    end
    
    SelectQuestLogEntry(temp)
  end
end

frame:SetScript("OnEvent", eventHandler)